{$B-}
uses
     skMHL,
     skOpen,
     skCommon,
     skComnTV,

     Wizard,

     Objects,
     Drivers;

const
 Version = '1.0';

var
 Base: PMessageBase;
 Posted: Boolean;

function ProcessMessage: Boolean;
 var
  Buffer: array[0..4096] of Char;
  Target: PMessageBase;
  Idle: Integer;
  First: Boolean;
  Address: TAddress;
  DT: TMessageBaseDateTime;
  S: String;
 begin
  Base^.SetTextPos(0);

  Idle:=0;
  First:=True;

  if not OpenOrCreateMessageBase(Target, ParamStr(2)) then
   begin
    PrintStr('unable to open target'#13#10);

    ProcessMessage:=False;

    Exit;
   end;

  if not Target^.CreateNewMessage then
   begin
    PrintStr('unable to create msg'#13#10);

    ProcessMessage:=False;

    Exit;
   end;

  if not StrToAddress(ParamStr(3), Address) then
   begin
    PrintStr('unable to parse address "' + ParamStr(3) + '"');

    ProcessMessage:=False;

    Exit;
   end;

  Target^.SetFlag(afEchomail, True);
  Target^.SetFlag(afNetmail, False);
  Target^.SetFlag(afLocal, False);

  Target^.SetFromAddress(Address, True);
  Target^.SetFrom('philushumor@onelist.com');
  Target^.SetTo('All');
  Target^.SetSubject('philushumor');

  GetCurrentMessageBaseDateTime(DT);

  Target^.SetWrittenDateTime(DT);
  Target^.SetArrivedDateTime(DT);

  Target^.SetAttribute(maLocal, True);
  Target^.SetAttribute(maSent, False);

  Target^.PutString(Concat(#1, 'PID: apumk v', Version, ', (q) by sk // [rAN] // [2:6033/27], 1999.'));

  while not Base^.EndOfMessage do
   begin
    Base^.GetStringPChar(Buffer, SizeOf(Buffer));

    S:=FromASCIIZ(@Buffer);

    if (S <> '') and (S[1] = #1) then
     Continue;

    if S = '--------------------------- ONElist Sponsor ----------------------------' then
     Break;

    if S = 'To: "HumorList" <philushumor@onelist.com>' then Continue;
    if S = 'Reply-To: philushumor-owner@onelist.com' then Continue;
    if S = 'From: "Phil Motuzko" <pumk@ksf.kiev.ua>' then Continue;

    if S = '' then
     Inc(Idle)
    else
     begin
      if First then
       begin
        Idle:=0;

        First:=False;
       end;

      while Idle <> 0 do
       begin
        Target^.PutString('');

        Dec(Idle);
       end;

      Target^.PutStringPChar(Buffer);
     end;
   end;

  Target^.PutString('');
  Target^.PutString(Concat('--- apumk v', Version));
  Target^.PutString(Concat(' * Origin: don''t forget to visit http://www.ftn2000.com (', AddressToStrEx(Address), ')'));

  if Target^.WriteMessage then
   begin
    PrintStr('ok'#13#10);

    Posted:=True;

    ProcessMessage:=True;
   end
  else
   begin
    PrintStr('unable to write message'#13#10);

    ProcessMessage:=False;
   end;

  Target^.CloseMessage;

  CloseMessageBase(Target);
 end;

var
 Address: TAddress;
begin
 PrintStr('apumk, v' + Version + ', (q) by sk // [rAN], 1999.'#13#10#13#10);

 InstallMHLcommon;

 if ParamCount < 3 then
  begin
   PrintStr('syntax: apumk IDsource IDdest address');

   Halt(255);
  end;

 if not OpenMessageBase(Base, ParamStr(1)) then
  begin
   PrintStr('unable to open source messagebase');

   Halt(254);
  end;

 Posted:=False;

 Base^.Seek(1);

 while Base^.SeekFound do
  begin
   PrintStr(#13 + 'msg#' + Long2Str(Base^.Current) + ': ');

   if not Base^.OpenMessage then
    begin
     CloseMessageBase(Base);

     PrintStr('unable to open message');

     Halt(253);
    end
   else
    begin
     Base^.GetFromAddress(Address);

     if (Base^.GetFrom = 'pumk@ksf.kiev.ua') and (AddressToStrEx(Address) = '2:5020/128') then
      if ProcessMessage then
       begin
        Base^.CloseMessage;

        Base^.KillMessage;

        Base^.SeekPrev;
       end
      else
       Base^.CloseMessage
     else
      Base^.CloseMessage;
    end;

   Base^.SeekNext;
  end;

 PrintStr('done.'#13#10);

 CloseMessageBase(Base);

 if Posted then
  Halt(1)
 else
  Halt(0);
end.